package main

import (
	"net/http"

	"github.com/gin-gonic/gin"
	"git.javil.eu/jacob1123/budgeteer/http"
	"git.javil.eu/jacob1123/budgeteer/postgres"
)

func main() {
	us := &postgres.UserService{}

	h := &http.Handler{UserService=us}
	h.Serve()
}

func restricted(c *gin.Context) {
	claims, ok := verifyLogin(c)
	if !ok {
		c.Redirect(http.StatusTemporaryRedirect, "/login")
		return
	}

	name := claims["name"].(string)
	c.String(http.StatusOK, "Welcome "+name+"!")
}

func login(c *gin.Context) {
	if _, ok := verifyLogin(c); ok {
		c.Redirect(http.StatusTemporaryRedirect, "/api/v1/hello")
		return
	}

	c.HTML(http.StatusOK, "login", nil)
}

func logout(c *gin.Context) {
	clearLogin(c)
}

func loginPost(c *gin.Context) {
	username, _ := c.GetPostForm("username")
	password, _ := c.GetPostForm("password")

	if username != "jan" || password != "passwort" {
		c.AbortWithStatus(http.StatusUnauthorized)
		return
	}

	loginSuccess(c, username, "Jan Bader")
}
